DOM::Attr class Reference (khtml Library)

| # khtml Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# DOM::Attr Class Reference

The `Attr` interface represents an attribute in an `Element` object. More...

`#include <dom_element.h>`

Inheritance diagram for DOM::Attr:

[legend]
Collaboration diagram for DOM::Attr:

[legend]
List of all members.

## Public Member Functions
| Attr (const Node &other)
| Attr (const Attr &other)
Attr & | operator= (const Node &other)
Attr & | operator= (const Attr &other)
DOMString | name () const
| Returns the name of this attribute.
bool | specified () const
| If this attribute was explicitly given a value in the original document, this is `true` ; otherwise, it is `false` .
DOMString | value () const
| On retrieval, the value of the attribute is returned as a string.
void | setValue (const DOMString &)
| see value
Element | ownerElement () const
| Introduced in DOM Level 2.
## Protected Member Functions
| Attr (AttrImpl *_impl)
## Friends
class | Element
class | Document
class | DocumentImpl
class | HTMLDocument
class | ElementImpl
class | NamedAttrMapImpl

## Detailed Description

The `Attr` interface represents an attribute in an `Element` object.

Typically the allowable values for the attribute are defined in a document type definition.

`Attr` objects inherit the `Node` interface, but since they are not actually child nodes of the element they describe, the DOM does not consider them part of the document tree. Thus, the `Node` attributes `parentNode` , `previousSibling` , and `nextSibling` have a null value for `Attr` objects. The DOM takes the view that attributes are properties of elements rather than having a separate identity from the elements they are associated with; this should make it more efficient to implement such features as default attributes associated with all elements of a given type. Furthermore, `Attr` nodes may not be immediate children of a `DocumentFragment` . However, they can be associated with `Element` nodes contained within a `DocumentFragment` . In short, users and implementors of the DOM need to be aware that `Attr` nodes have some things in common with other objects inheriting the `Node` interface, but they also are quite distinct.

The attribute's effective value is determined as follows: if this attribute has been explicitly assigned any value, that value is the attribute's effective value; otherwise, if there is a declaration for this attribute, and that declaration includes a default value, then that default value is the attribute's effective value; otherwise, the attribute does not exist on this element in the structure model until it has been explicitly added. Note that the `nodeValue` attribute on the `Attr` instance can also be used to retrieve the string version of the attribute's value(s).

In XML, where the value of an attribute can contain entity references, the child nodes of the `Attr` node provide a representation in which entity references are not expanded. These child nodes may be either `Text` or `EntityReference` nodes. Because the attribute type may be unknown, there are no tokenized attribute values.

Definition at line 88 of file dom_element.h.

## Member Function Documentation

DOMString Attr::name | ( |  | ) | const

| Returns the name of this attribute. Definition at line 70 of file dom_element.cpp.

bool Attr::specified | ( |  | ) | const

| If this attribute was explicitly given a value in the original document, this is `true` ; otherwise, it is `false` . Note that the implementation is in charge of this attribute, not the user. If the user changes the value of the attribute (even if it ends up having the same value as the default value) then the `specified` flag is automatically flipped to `true` . To re-specify the attribute as the default value from the DTD, the user must delete the attribute. The implementation will then make a new attribute available with `specified` set to `false` and the default value (if one exists). In summary: If the attribute has an assigned value in the document then `specified` is `true` , and the value is the assigned value. If the attribute has no assigned value in the document and has a default value in the DTD, then `specified` is `false` , and the value is the default value in the DTD. If the attribute has no assigned value in the document and has a value of #IMPLIED in the DTD, then the attribute does not appear in the structure model of the document. Definition at line 78 of file dom_element.cpp.

DOMString Attr::value | ( |  | ) | const

| On retrieval, the value of the attribute is returned as a string. Character and general entity references are replaced with their values. On setting, this creates a `Text` node with the unparsed contents of the string. Definition at line 90 of file dom_element.cpp.

void Attr::setValue | ( | const DOMString & |  | ) |

| see value Definition at line 96 of file dom_element.cpp.

Element Attr::ownerElement | ( |  | ) | const

| Introduced in DOM Level 2. The Element node this attribute is attached to or null if this attribute is not in use. Definition at line 84 of file dom_element.cpp. Referenced by DOM::Element::removeAttributeNode().

The documentation for this class was generated from the following files:

- dom_element.h
- dom_element.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:36:01 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001